// $$root$$Dlg.h : header file
//

#pragma once

#if !defined(AFX_DXAPPDLG_H__7420D558_E6EF_11D7_875D_0050BABA906A__INCLUDED_)
#define AFX_DXAPPDLG_H__7420D558_E6EF_11D7_875D_0050BABA906A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <qedit.h>

#include "apSel.h"
#include "CompSel.h"


#define EC_DEFINEMESSAGEHERE EC_USER+1

#define EXECUTE_ASSERT(_x_) ASSERT(_x_)
#define CHECK_RELEASE(i) {if (i) i->Release(); i = NULL;}
#define CHECK(x) if (FAILED(hr=(x))) \
    {RetailOutput(TEXT("FAILED(0x%x) ") TEXT(#x) TEXT("\n\0"), hr); return hr;}
#define WM_GRAPHNOTIFY WM_APP+1
/////////////////////////////////////////////////////////////////////////////
// C[!output PROJECT_NAME]Dlg dialog
/////////////////////////////////////////////////////////////////////////////


class C[!output PROJECT_NAME]Dlg : public CDialog
{
// Construction
public:
	C[!output PROJECT_NAME]Dlg(CWnd* pParent = NULL);	// standard constructor
    HRESULT InitDirectShow(void);
    HRESULT FreeDirectShow(void);
    void RetailOutput(TCHAR *tszErr, ...);
	void ReleaseObj();
	HRESULT PlayFile();
	HRESULT PlayCap();
	CMenu m_Menu, m_File,m_Option;

	IBaseFilter * FindFilter (CONST GUID * gui,LPCTSTR Filter);
	IPin * GetPin(IBaseFilter * lpFilter, LPSTR InPin);
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
	HRESULT BindDefault(int mode);
	void SaveDefaults();
	void LoadDefaults();
	void RemoveFromRot(DWORD pdwRegister);
	HRESULT EnumFilters (IFilterGraph *pGraph) ;

	HRESULT SaveGraphFile(IGraphBuilder *pGraph, WCHAR *wszPath) ;

	
	// Dialog Data

	//{{AFX_DATA(C[!output PROJECT_NAME]Dlg)
	enum { IDD = IDD_MVTEMPLATE_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(C[!output PROJECT_NAME]Dlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	DWORD dwRegister;


	IGraphBuilder *			m_pGrB   ;
	ICaptureGraphBuilder2 * m_pBld ;
	IFilterGraph *			m_pFil;


	IMediaControl *			m_pMedC  ;
	IMediaEventEx *			m_pMedE  ;
	IMediaSeeking *			m_pMedS  ;
	IMediaPosition *		m_pMedP ;
	IVideoWindow  *			m_pVidW  ;
	IBasicAudio   *			m_pBasA  ;
	IBasicVideo   *			m_pBasV  ;
	IBaseFilter *			m_pFilter;
	IBaseFilter *			m_captureFilter;

	ICreateDevEnum *		pSysDevEnum;

	CString m_capdev;
	CString m_processfilter;
	CapSel dlgCapsel;
	CCompSel  dlgCompsel;

	// Generated message map functions
	//{{AFX_MSG(C[!output PROJECT_NAME]Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnShowpropertypage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DXAPPDLG_H__7420D558_E6EF_11D7_875D_0050BABA906A__INCLUDED_)

